import QtQuick 2.12
import QtQuick.Window 2.0
import "./part"
import "./mousebase"
Rectangle {
    objectName: "mainRect"
    id: mainWindow
    visible: true
    property string dropImagePath: ""
    signal sendDropImagePath(var path)
    property int mouseMoveDistance: 0
    property point startPressPoint: Qt.point(-1,-1)
    property point releasePoint: Qt.point(-1,-1)
    property bool mouseIsDoubleClick: false
    signal changeImage(var nextOrBack)
    signal doubleSignal()
    Variables { id: variables }
    ImageBaseFunction {id: imageBase}
    onWidthChanged: {
        variables.curWidW = width
    }
    onHeightChanged: {
        variables.curWidH = height
    }

    //鼠标事件响应区域
    MouseAreaEvent { id: mouseshortcuts }
    //外边框---最外层的，需要用到别的组件相对于它的位置
    Image {
        id: bgimage
        anchors.fill: parent
        MouseArea {
            id: mousemouse
            anchors.fill: parent
            hoverEnabled: true
            onReleased: {
                //导航栏存在的话直接return
               if (variables.navigatorState) {
                   return
               }
               if (mouseIsDoubleClick) {
                   mouseIsDoubleClick = false
                   return
               }
                releasePoint = Qt.point(mouseX, mouseY)
                mouseMoveDistance = releasePoint.x - startPressPoint.x

                if (mouseMoveDistance > 100) {
                    //切换图图片
                    changeImage(true)
                }
                if (mouseMoveDistance < -100) {
                    //切换图图片
                    changeImage(false)
                }

            }

            onPressed: {
                startPressPoint = Qt.point(mouseX, mouseY)
            }
            onPositionChanged: {
                variables.mousePos = Qt.point(mouseX, mouseY)
            }
            onMouseXChanged: {
                variables.mouseCurPos = Qt.point(mouseX, mouseY)
            }
            onMouseYChanged: {
                variables.mouseCurPos = Qt.point(mouseX, mouseY)
            }
            onDoubleClicked: {
                mouseIsDoubleClick = true
                doubleSignal()
            }
        }
    }

    //主要的图片区域
    MainImageArea {
        objectName: "imageItem"
        id: imageArea
        x: 0
        y: 0
        width: mainWindow.width
        height: mainWindow.height
    }
    //拖拽文件打开图片
    DropArea{
        anchors.fill: parent
        onDropped: {
            if (drop.hasUrls) {
                if (drop.urls.length > 0) {
                    dropImagePath = drop.urls[0]
                    sendDropImagePath(drop.urls[0])
                }
            }
        }
    }

}

